'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _ast = require('./utils/ast');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var parser = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(code) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var defaultOptions, ast, moduleIdentifier;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            defaultOptions = (0, _extends3.default)({
              sourceType: 'module',
              moduleName: 'crates',
              plugins: []
            }, options);
            ast = (0, _ast.getASTFromCode)(code, {
              sourceType: defaultOptions.sourceType,
              plugins: ['doExpressions', 'objectRestSpread', 'decorators', 'decorators2', 'classProperties', 'exportDefaultFrom', 'exportNamespaceFrom', 'asyncGenerators', 'dynamicImport', 'jsx', 'flow', 'flowComments', 'typescript'].concat((0, _toConsumableArray3.default)(defaultOptions.plugins))
            });
            _context.prev = 2;
            _context.next = 5;
            return (0, _ast.getModuleIdentifier)(ast, defaultOptions.moduleName);

          case 5:
            moduleIdentifier = _context.sent;
            return _context.abrupt('return', (0, _ast.getTranslationsMap)(ast, moduleIdentifier));

          case 9:
            _context.prev = 9;
            _context.t0 = _context['catch'](2);

            console.error('Parser:', _context.t0);
            return _context.abrupt('return', new _map2.default());

          case 13:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[2, 9]]);
  }));

  return function parser(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = parser;